// Desktop Rox - A game by Stephen Stair (sgstair@akkit.org) for LudumDare 11 (48h game competition)
// DesktopSpriteManager - system for rendering sprites on the desktop :>

#pragma once
#include "spritemanager.h"
#include <windows.h>
#include "Bitmap.h"
#include <vector>
using namespace std;

class DesktopSpriteRecord
{
public:
	BitmapSprite * sprite;
	HWND hWnd;
	Bitmap cachedbmp;
};


class DesktopSpriteManager :
	public SpriteManager
{
public:
	DesktopSpriteManager(void);
	virtual ~DesktopSpriteManager(void);

	virtual int GetFieldWidth();
	virtual int GetFieldHeight();
	virtual vector<BoundaryPoint> GetFieldBoundary();  // boundary points traverse the screen(s) CLOCKWISE
	virtual RECT GetMainWindow();

	virtual void SetClickHandler(fptrClickHandler h);


	virtual void AddSprite( BitmapSprite * sprite );
	virtual bool RemoveSprite( BitmapSprite * sprite );

	virtual void Redraw();

protected:
	static void UpdateDSRWindow(DesktopSpriteRecord * dsr);
	static BOOL CALLBACK EnumProc( HMONITOR hMon, HDC hDC, LPRECT lpmonitorrect, LPARAM data );

	static LRESULT WINAPI WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	vector<DesktopSpriteRecord*> mysprites;

	vector<RECT> windows;
	int primarywindow;
	static int x_offset, y_offset;
	int width, height;
	vector<BoundaryPoint> cachedboundary;
	static fptrClickHandler myhandler;
};



