// Desktop Rox - A game by Stephen Stair (sgstair@akkit.org) for LudumDare 11 (48h game competition)
// OriginalRasterizer - The first rasterizer idea I came up with. I'll probably add others too.

#pragma once
#include "rasterizer.h"

class OriginalRasterizer :
	public Rasterizer
{
public:
	OriginalRasterizer(void);
	virtual ~OriginalRasterizer(void);

	virtual void Bind(Bitmap * bmp, double zerox=0.0, double zeroy=0.0);

	virtual void DrawClosedFigure( int num_points, RenderPoint * rp, double rotation=0.0, double scale=1.0 );

	virtual void DrawRectangles( int num_rectangles, RenderRectangle * rr, double rotation=0.0, double scale=1.0 );

	virtual void FlushChanges();


protected:
	void DrawFilledQuad( RenderPoint * rp, Color c );

	Bitmap * bound_bmp;
	double zx, zy;
};
