// Desktop Rox - A game by Stephen Stair (sgstair@akkit.org) for LudumDare 11 (48h game competition)
// WindowSpriteManager - tool for rendering sprites within a window, for testing purposes (and as a fallback if the desktop version doesn't work)

#pragma once
#include "spritemanager.h"
#include "Bitmap.h"

#include <windows.h>

#include <vector>
using namespace std;


class WindowSpriteRecord
{
public:
	BitmapSprite * sprite;

};


class WindowSpriteManager :
	public SpriteManager
{
public:
	WindowSpriteManager(int width, int height);
	virtual ~WindowSpriteManager(void);


	virtual int GetFieldWidth();
	virtual int GetFieldHeight();
	virtual vector<BoundaryPoint> GetFieldBoundary();  // boundary points traverse the screen(s) CLOCKWISE
	virtual RECT GetMainWindow();


	virtual void AddSprite( BitmapSprite * sprite );
	virtual bool RemoveSprite( BitmapSprite * sprite );

	virtual void Redraw();

protected:
	static LRESULT WINAPI WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	static HWND hWnd;
	static Bitmap cachebmp;
	vector<WindowSpriteRecord> mysprites;
};
